# include "gchars.h"
#include <strings.h>
#include <stdlib.h>
# include <unistd.h>

#define CTRL    0x0100       
#define NODATA  0x08FF
#define Ctrl_it(x)	(CTRL|((x)+'@'))
#define Uctr_it(x)	(((x)-'@')&(~CTRL))

int TOGGLE_KEY = Uctr_it (CTRL|'\\');

static char oweclr = 0;
static unsigned char **currentmap = &map_eng [0];

extern int notitle;

int cGetKey (unsigned char *arg)
{

  unsigned char chr;
  static TOGGLE_OCCURED = 0;

  /* each time, initialize the toggle key to GRTGL */
  map_eng [TOGGLE_KEY] = 
  map_grk [TOGGLE_KEY] = GRTGL;

  while (1) {
    /* get the original key from read() */
    if (read (0, &chr, 1) <= 0) {
      return (-1);
    }

    if (TOGGLE_OCCURED) {
	if (currentmap[chr] != GRTGL)
		TOGGLE_OCCURED = 0;
	else {
		if (!notitle && (!strcmp(getenv("TERM"), "xterm"))) {
			if (currentmap == &map_eng[0])
			 write(1, "\033]2;Greek mode\007",sizeof("\033]2;Greek mode\007"));

			else 
			 write(1, "\033]2;English mode\007",sizeof("\033]2;English mode\007"));
		}
		TOGGLE_OCCURED = 0;
		if (currentmap == &map_eng[0])
		    currentmap = &map_grk[0];
		else
		    currentmap = &map_eng[0];
		*arg = chr;
		return (1);
	}
    }
		
    switch ((int ) currentmap [chr]) {
      case NOFUN:
	oweclr++;
	write (1, "\007 \b", 3);
	currentmap = &map_grk [0];
	continue;
      case GRTGL:
	if (!notitle && (!strcmp(getenv("TERM"), "xterm"))){ 
			if (currentmap == &map_eng[0])
			 write(1, "\033]2;Greek mode\007",sizeof("\033]2;Greek mode\007"));
			else 
			 write(1, "\033]2;English mode\007",sizeof("\033]2;English mode\007"));
	}

	TOGGLE_OCCURED = 1;
	if (currentmap == &map_eng [0]) {
	  currentmap = &map_grk [0];
	}
	else {
	  if (oweclr) {
	    oweclr = 0;
	  write (1, " \b", 2);
	  }
	  currentmap = &map_eng [0];
	}
	continue;
      case ACCNT:
	oweclr++;
	write (1, "\b", 2);
	currentmap = &map_acc [0];
	continue;
      case DIAIR:
	oweclr++;
	write (1, "\b", 2);
	currentmap = &map_drs [0];
	continue;
      case ACCDR:
	oweclr++;
	write (1, "\b", 2);
	currentmap = &map_acd [0];
	continue;
      case CARET:
	oweclr++;
	write (1, "^\b", 2);
	currentmap = &map_car [0];
	continue;
      case ESCMD:				/* is this code ever used? */
	if (oweclr) {
	  oweclr = 0;
	  write (1, " \b", 2);
	}
	currentmap = &map_eng [0];
	*arg = '\033';
	return (1);
      default:
	if (oweclr) {
	  oweclr = 0;
	  write (1, " \b", 2);
	}
	chr = (int) *currentmap [chr];
	if (currentmap != &map_eng [0] && currentmap != &map_grk [0]) {
	  currentmap = &map_grk [0];
	}
	*arg = chr;
	return (1);
    }
  }
}
